天天看點

Prime Path POJ3126

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?

— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033

1733

3733

3739

3779

8779

8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033
           

Sample Output

6
7
0
           

沒有impossible也過了,。。。。emmmmm。

我的方法很蠢。

先打表,然後一個個搜。

#include <iostream>
#include <stdio.h>
#include<queue>
#include<string.h>
using namespace std;
struct e
{
    int data;
    int ans;
};
int a[10000],flag;
bool vis[10000];
void da()
{
    int i;
    for(i=2;i<10000;i++)
    {
        if(a[i]==0)
        {
            for(int j=i*2;j<10000;j+=i)
                a[j]=1;
        }
    }
}

void bfs()
{
    flag=0;
    e e1,e2;
    int x,y,ans=0;
    scanf("%d%d",&x,&y);
    e1.data=x,e1.ans=0;
    vis[x]=true;
    queue<e>q;
    q.push(e1);
    while(q.size())
    {
        e1=q.front();
        q.pop();
        if(e1.data==y)
        {
            flag=1;
            printf("%d\n",e1.ans);
            break;
        }
        int k=e1.data/10*10;
            for(int i=k;i<k+10;i++)
                if(!a[i]&&vis[i]==false)
            {
                e2.data=i;
                e2.ans=e1.ans+1;
                vis[i]=true;
                q.push(e2);
            }
            k=(e1.data/10)%10;
            k=e1.data-k*10;
            for(int i=k;i<k+100;i+=10)
                if(!a[i]&&vis[i]==false)
            {
                e2.data=i;
                e2.ans=e1.ans+1;
                vis[i]=true;
                q.push(e2);
            }
            k=(e1.data/100)%10;
            k=e1.data-k*100;
            for(int i=k;i<k+1000;i+=100)
                if(!a[i]&&vis[i]==false)
            {
                e2.data=i;
                e2.ans=e1.ans+1;
                vis[i]=true;
                q.push(e2);
            }

            k=(e1.data/1000)%10;
            k=e1.data-(k-1)*1000;
            for(int i=k;i<10000;i+=1000)
                if(!a[i]&&vis[i]==false)
            {
                e2.data=i;
                e2.ans=e1.ans+1;
                vis[i]=true;
                q.push(e2);
            }
    }
    if(!flag)printf("Impossible\n");
}
int main()
{
    int n,i ;
    scanf("%d",&n);
    da();
    while(n--)
    {
        memset(vis,false,sizeof(vis));
        bfs();
    }
//    for(i=2; i<10000; i++)
//        if(!a[i])
//            cout<<i<<endl;
    //cout << "Hello world!" << endl;
    return 0;
}